/*
	Add by Alan , 07-29-2005
	For ATMEL AT24C16 EEPROM
*/

#include <common.h>
#include <i2c.h>
#ifdef CFG_EEPROM_AT24C16
#undef DEBUG
/*
void
void i2c_init(int speed, int slaveaddr);
int i2c_read(uchar chip, uint addr, int alen, uchar *buffer, int len);
int i2c_write(uchar chip, uint addr, int alen, uchar *buffer, int len);
*/


void eeprom_init  (void)
{
	

#if defined(CONFIG_HARD_I2C) || defined(CONFIG_SOFT_I2C)
	i2c_init (CFG_I2C_SPEED, CFG_I2C_SLAVE);
#endif
	/*if(eeprom_probe(0x50, 0)==0)
		printf("EEPROM Found!\n");*/
}

int eeprom_read (unsigned dev_addr, int offset, uchar *buffer, int cnt)
{
	
	int page,count=0,i=0;
        
        page = offset / 0x100;
        i = offset % 0x100;  
        
        
	
	while(count < cnt){
        	
        	
        	if (i2c_read (dev_addr|page, i++, 1, buffer+count++, 1) != 0)
			return 1; 
		if(i > 0xff){
			page++;
			i = 0;
			}	
		
        	
        }
	
	return 0;
	
	
}

/*-----------------------------------------------------------------------
 *
 * for CFG_I2C_EEPROM_ADDR_LEN == 2 (16-bit EEPROM address) offset is
 *   0x000nxxxx for EEPROM address selectors at n, offset xxxx in EEPROM.
 *
 * for CFG_I2C_EEPROM_ADDR_LEN == 1 (8-bit EEPROM page address) offset is
 *   0x00000nxx for EEPROM address selectors and page number at n.
 */

int eeprom_write (unsigned dev_addr, int offset, uchar *buffer, int cnt)
{
	
	int page,i=0,count=0;
        
        page = offset / 0x100;
        i = offset % 0x100;
       
        
        while(count < cnt){
        	
        	if (i2c_write (dev_addr|page, i++, 1, buffer+count++, 1) != 0) 
				return 1; 
		if(i > 0xff){
			page++;
			i =0;
		}			
		
        	
        }
      

#if defined(CFG_EEPROM_PAGE_WRITE_DELAY_MS)
		udelay(CFG_EEPROM_PAGE_WRITE_DELAY_MS * 1000);
#endif
	
	return 0;
}

#ifndef CONFIG_SPI
int
eeprom_probe (unsigned dev_addr, unsigned offset)
{
	unsigned char chip;

	/* Probe the chip address
	 */
#if CFG_I2C_EEPROM_ADDR_LEN == 1 && !defined(CONFIG_SPI_X)
	chip = offset >> 8;		/* block number */
#else
	chip = offset >> 16;		/* block number */
#endif	/* CFG_I2C_EEPROM_ADDR_LEN, CONFIG_SPI_X */

	chip |= dev_addr;		/* insert device address */
 //       printf("i2c_chip:%x\n", chip);
	return (i2c_probe (chip));
}
#endif
#endif

