#include <common.h>
#include <asm/arch/matrix500.h>

#ifdef CFG_MATRIX500
void matrix500_gpio_init(void){
	
	AT91C_BASE_PIOD->PIO_PER=1<<(MATRIX500_DEBUG_LED1-96)|1<<(MATRIX500_DEBUG_LED2-96)|1<<(MATRIX500_DEBUG_LED3-96)|1<<(MATRIX500_DEBUG_LED4-96)| 1<<(MATRIX500_READY_LED-96);

	AT91C_BASE_PIOD->PIO_OER =1<<(MATRIX500_DEBUG_LED1-96)|1<<(MATRIX500_DEBUG_LED2-96)|1<<(MATRIX500_DEBUG_LED3-96)| 1<<(MATRIX500_DEBUG_LED4-96)|1<<(MATRIX500_READY_LED-96);
	AT91C_BASE_PIOD->PIO_SODR = 1<<(MATRIX500_READY_LED-96); //Ready LED
	AT91C_BASE_PIOD->PIO_CODR = 1<<(MATRIX500_DEBUG_LED3-96); //LED3:ON
	AT91C_BASE_PIOB->PIO_PER = 1<<(MATRIX500_BUZZER-32);
	AT91C_BASE_PIOB->PIO_OER = 1<<(MATRIX500_BUZZER-32);
	AT91C_BASE_PIOC->PIO_PDR = (1<<7) | (1<<8); //A23, A24
	/* Power OFF all USART's LEDs */
	AT91C_BASE_PIOA->PIO_PER =  AT91C_PA5_TXD3|AT91C_PA6_RXD3|AT91C_PA17_TXD0|AT91C_PA18_RXD0|AT91C_PA22_RXD2|   AT91C_PA23_TXD2;
	AT91C_BASE_PIOA->PIO_OER =  AT91C_PA5_TXD3|AT91C_PA6_RXD3|AT91C_PA17_TXD0|AT91C_PA18_RXD0|AT91C_PA22_RXD2|    AT91C_PA23_TXD2;
	AT91C_BASE_PIOA->PIO_SODR = AT91C_PA5_TXD3|AT91C_PA6_RXD3|AT91C_PA17_TXD0|AT91C_PA18_RXD0|AT91C_PA22_RXD2|    AT91C_PA23_TXD2;
	AT91C_BASE_PIOB->PIO_PER = AT91C_PB20_RXD1|AT91C_PB21_TXD1;
	AT91C_BASE_PIOB->PIO_OER = AT91C_PB20_RXD1|AT91C_PB21_TXD1;
	AT91C_BASE_PIOB->PIO_SODR = AT91C_PB20_RXD1|AT91C_PB21_TXD1;


}

uchar matrix500_gpio_set(MATRIX500_PIO io){
	uchar status = 0xff;
	switch(io){
		case MATRIX500_DEBUG_LED1:
		case MATRIX500_DEBUG_LED2:
		case MATRIX500_DEBUG_LED3:
		case MATRIX500_DEBUG_LED4:
		case MATRIX500_READY_LED:
			AT91C_BASE_PIOD->PIO_SODR = 1<<(io-96);
			status = AT91C_BASE_PIOD->PIO_ODSR & (1<<(io-96));
		break;
		case MATRIX500_BUZZER:
			AT91C_BASE_PIOB->PIO_SODR = 1<<(io-32);
			status = AT91C_BASE_PIOB->PIO_ODSR & (1<<(io-32));
		break;		
	}
	return status;
}	
uchar matrix500_gpio_clear(MATRIX500_PIO io){
	uchar status = 0xff;
	switch(io){
		case MATRIX500_DEBUG_LED1:
		case MATRIX500_DEBUG_LED2:
		case MATRIX500_DEBUG_LED3:
		case MATRIX500_DEBUG_LED4:
		case MATRIX500_READY_LED:
			AT91C_BASE_PIOD->PIO_CODR = 1<<(io-96);
			status = AT91C_BASE_PIOD->PIO_ODSR & (1<<(io-96));
		break;
		case MATRIX500_BUZZER:
			AT91C_BASE_PIOB->PIO_CODR = 1<<(io-32);
			status = AT91C_BASE_PIOB->PIO_ODSR & (1<<(io-32));
		break;		
	}
	return status;
}	
#endif
