#ifndef _STAR_GSW_H_
#define _STAR_GSW_H_

/******************************************************************************
 * MODULE NAME:    star_gsw.h
 * PROJECT CODE:   Orion
 * DESCRIPTION:    
 * MAINTAINER:     MJLIU
 * DATE:           11 July 2003
 *
 * SOURCE CONTROL: 
 *
 * LICENSE:
 *     This source code is copyright (c) 2003 Star Semi Inc.
 *     All rights reserved.
 *
 * REVISION HISTORY:
 *    11 July 2003  -  MJLIU	- Initial Version v1.0
 *
 *
 * SOURCE:
 * ISSUES:
 * NOTES TO USERS:
 ******************************************************************************/

#include "sys_apb_memory_map.h"



#define GSW_BASE_ADDR                                APB_DEVICES_MEM_MAP_ADDR(GSW_BASE)

#define GSW_PHY_CONTROL_REG_OFFSET                   0x000

#define GSW_SWITCH_CONFIG_REG_OFFSET                 0x004

#define GSW_MAC_PORT_0_CONFIG_REG_OFFSET             0x008
#define GSW_MAC_PORT_1_CONFIG_REG_OFFSET             0x00C
#define GSW_CPU_PORT_CONFIG_REG_OFFSET               0x010

#define GSW_PRIORITY_CONTROL_REG_OFFSET              0x014

#define GSW_UDP_PRIORITY_REG_OFFSET                  0x018

#define GSW_IP_TOS_0_7_PRIORITY_REG_OFFSET           0x01C
#define GSW_IP_TOS_8_15_PRIORITY_REG_OFFSET          0x020
#define GSW_IP_TOS_16_23_PRIORITY_REG_OFFSET         0x024
#define GSW_IP_TOS_24_31_PRIORITY_REG_OFFSET         0x028
#define GSW_IP_TOS_32_39_PRIORITY_REG_OFFSET         0x02C
#define GSW_IP_TOS_40_47_PRIORITY_REG_OFFSET         0x030
#define GSW_IP_TOS_48_55_PRIORITY_REG_OFFSET         0x034
#define GSW_IP_TOS_56_63_PRIORITY_REG_OFFSET         0x038

#define GSW_SCHEDULER_CONTROL_REG_OFFSET             0x03C
#define GSW_RATE_LIMIT_CONTROL_REG_OFFSET            0x040

#define GSW_FLOW_CONTROL_GLOBAL_THRESHOLD_REG_OFFSET 0x044
#define GSW_FLOW_CONTROL_PORT_THRESHOLD_REG_OFFSET   0x048

#define GSW_SMART_FLOW_CONTROL_REG_OFFSET            0x04C

#define GSW_ARL_TABLE_ACCESS_CONTROL_0_REG_OFFSET    0x050
#define GSW_ARL_TABLE_ACCESS_CONTROL_1_REG_OFFSET    0x054
#define GSW_ARL_TABLE_ACCESS_CONTROL_2_REG_OFFSET    0x058

#define GSW_VLAN_PORT_PVID_REG_OFFSET                0x05C

#define GSW_VLAN_VID_0_1_REG_OFFSET                  0x060
#define GSW_VLAN_VID_2_3_REG_OFFSET                  0x064
#define GSW_VLAN_VID_4_5_REG_OFFSET                  0x068
#define GSW_VLAN_VID_6_7_REG_OFFSET                  0x06C

#define GSW_VLAN_MEMBER_PORT_MAP_REG_OFFSET          0x070

#define GSW_VLAN_TAG_PORT_MAP_REG_OFFSET             0x074

#define GSW_PPPOE_SESSION_ID_0_1_REG_OFFSET          0x078
#define GSW_PPPOE_SESSION_ID_2_3_REG_OFFSET          0x07C
#define GSW_PPPOE_SESSION_ID_4_5_REG_OFFSET          0x080
#define GSW_PPPOE_SESSION_ID_6_7_REG_OFFSET          0x084

#define GSW_INTERRUPT_STATUS_REG_OFFSET              0x088
#define GSW_INTERRUPT_MASK_REG_OFFSET                0x08C

#define GSW_PORT_MIRROR_REG_OFFSET                   0x090

#define GSW_BIST_RESULT_TEST_0_REG_OFFSET            0x094
#define GSW_QUEUE_STATUS_TEST_1_REG_OFFSET           0x098

#define GSW_ISP_TAGGING_PORT_CONFIG_REG_OFFSET       0x09C

#define GSW_TS_DMA_CONTROL_REG_OFFSET                0x100
#define GSW_FS_DMA_CONTROL_REG_OFFSET                0x104
#define GSW_TS_DESCRIPTOR_POINTER_REG_OFFSET         0x108
#define GSW_FS_DESCRIPTOR_POINTER_REG_OFFSET         0x10C
#define GSW_TS_DESCRIPTOR_BASE_ADDR_REG_OFFSET       0x110
#define GSW_FS_DESCRIPTOR_BASE_ADDR_REG_OFFSET       0x114

#define GSW_DELAYED_INTERRUPT_CONFIG_REG_OFFSET      0x118

#define GSW_HNAT_CONFIG_REG_OFFSET                   0x200

#define GSW_HNAT_PRIVATE_IP_BASE_REG_OFFSET          0x204

#define GSW_HNAT_DMAC_0_HIGH_ENTRY_REG_OFFSET        0x208
#define GSW_HNAT_DMAC_0_LOW_ENTRY_REG_OFFSET         0x20C

#define GSW_HNAT_DMAC_1_HIGH_ENTRY_REG_OFFSET        0x210
#define GSW_HNAT_DMAC_1_LOW_ENTRY_REG_OFFSET         0x214

#define GSW_HNAT_DMAC_2_HIGH_ENTRY_REG_OFFSET        0x218
#define GSW_HNAT_DMAC_2_LOW_ENTRY_REG_OFFSET         0x21C

#define GSW_HNAT_DMAC_3_HIGH_ENTRY_REG_OFFSET        0x220
#define GSW_HNAT_DMAC_3_LOW_ENTRY_REG_OFFSET         0x224

#define GSW_HNAT_FW_RULE_START_ADDR_REG_OFFSET       0x228
#define GSW_HNAT_FW_RULE_END_ADDR_REG_OFFSET         0x22C

#define GSW_HNAT_FL_RULE_START_ADDR_REG_OFFSET       0x230
#define GSW_HNAT_FL_RULE_END_ADDR_REG_OFFSET         0x234

#define GSW_HNAT_ALG_START_ADDR_REG_OFFSET           0x238
#define GSW_HNAT_ALG_END_ADDR_REG_OFFSET             0x23C

#define GSW_HNAT_SIP_BASE_ADDR_REG_OFFSET            0x240

#define GSW_HNAT_NAPT_BASE_ADDR_REG_OFFSET           0x244

#define GSW_HNAT_NAPT_PORT_BASE_REG_OFFSET           0x248

#define GSW_HNAT_ARP_BASE_ADDR_REG_OFFSET            0x24C

#define GSW_HNAT_TCP_SNA_THRESHOLD_REG_OFFSET        0x250

#define GSW_HNAT_SOURCE_MAC_0_HIGH_OFFSET	     0x254

#define GSW_HNAT_SOURCE_MAC_0_LOW_OFFSET	     0x258

#define GSW_HNAT_SOURCE_MAC_1_HIGH_OFFSET	     0x25C	

#define GSW_HNAT_SOURCE_MAC_1_LOW_OFFSET	     0x260

#define GSW_HNAT_SOURCE_MAC_2_HIGH_OFFSET	     0x264

#define GSW_HNAT_SOURCE_MAC_2_LOW_OFFSET	     0x268

#define GSW_HNAT_SOURCE_MAC_3_HIGH_OFFSET	     0x26C	

#define GSW_HNAT_SOURCE_MAC_3_LOW_OFFSET	     0x270

#define GSW_HNAT_SOURCE_MAC_4_HIGH_OFFSET	     0x274

#define GSW_HNAT_SOURCE_MAC_4_LOW_OFFSET	     0x278

#define GSW_HNAT_SOURCE_MAC_5_HIGH_OFFSET	     0x27C	

#define GSW_HNAT_SOURCE_MAC_5_LOW_OFFSET	     0x280

#define GSW_HNAT_SOURCE_MAC_6_HIGH_OFFSET	     0x284

#define GSW_HNAT_SOURCE_MAC_6_LOW_OFFSET	     0x288

#define GSW_HNAT_SOURCE_MAC_7_HIGH_OFFSET	     0x28C	

#define GSW_HNAT_SOURCE_MAC_7_LOW_OFFSET	     0x290

#define GSW_HNAT_TCP_MSS_LIMIT_OFFSET	             0x294

#define GSW_HNAT_AGING_CONFIG_OFFSET	             0x298



#define GSW_MEM_MAP_ADDR(regname)          (GSW_BASE_ADDR + GSW_##regname##_OFFSET)
 
#define GSW_MEM_MAP_VALUE(regname)         (*((u_int32 volatile *)GSW_MEM_MAP_ADDR(regname)))


/*
 * define access macros
 */
#define GSW_PHY_CONTROL                    GSW_MEM_MAP_VALUE(PHY_CONTROL_REG)

#define GSW_SWITCH_CONFIG                  GSW_MEM_MAP_VALUE(SWITCH_CONFIG_REG)

#define GSW_MAC_PORT_0_CONFIG              GSW_MEM_MAP_VALUE(MAC_PORT_0_CONFIG_REG)
#define GSW_MAC_PORT_1_CONFIG              GSW_MEM_MAP_VALUE(MAC_PORT_1_CONFIG_REG)
#define GSW_CPU_PORT_CONFIG                GSW_MEM_MAP_VALUE(CPU_PORT_CONFIG_REG)

#define GSW_PRIORITY_CONTROL               GSW_MEM_MAP_VALUE(PRIORITY_CONTROL_REG)

#define GSW_UDP_PRIORITY                   GSW_MEM_MAP_VALUE(UDP_PRIORITY_REG)

#define GSW_IP_TOS_0_7_PRIORITY            GSW_MEM_MAP_VALUE(IP_TOS_0_7_PRIORITY_REG)
#define GSW_IP_TOS_8_15_PRIORITY           GSW_MEM_MAP_VALUE(IP_TOS_8_15_PRIORITY_REG)
#define GSW_IP_TOS_16_23_PRIORITY          GSW_MEM_MAP_VALUE(IP_TOS_16_23_PRIORITY_REG)
#define GSW_IP_TOS_24_31_PRIORITY          GSW_MEM_MAP_VALUE(IP_TOS_24_31_PRIORITY_REG)
#define GSW_IP_TOS_32_39_PRIORITY          GSW_MEM_MAP_VALUE(IP_TOS_32_39_PRIORITY_REG)
#define GSW_IP_TOS_40_47_PRIORITY          GSW_MEM_MAP_VALUE(IP_TOS_40_47_PRIORITY_REG)
#define GSW_IP_TOS_48_55_PRIORITY          GSW_MEM_MAP_VALUE(IP_TOS_48_55_PRIORITY_REG)
#define GSW_IP_TOS_56_63_PRIORITY          GSW_MEM_MAP_VALUE(IP_TOS_56_63_PRIORITY_REG)

#define GSW_SCHEDULER_CONTROL              GSW_MEM_MAP_VALUE(SCHEDULER_CONTROL_REG)
#define GSW_RATE_LIMIT_CONTROL             GSW_MEM_MAP_VALUE(RATE_LIMIT_CONTROL_REG)

#define GSW_FLOW_CONTROL_GLOBAL_THRESHOLD  GSW_MEM_MAP_VALUE(FLOW_CONTROL_GLOBAL_THRESHOLD_REG)
#define GSW_FLOW_CONTROL_PORT_THRESHOLD    GSW_MEM_MAP_VALUE(FLOW_CONTROL_PORT_THRESHOLD_REG)

#define GSW_SMART_FLOW_CONTROL             GSW_MEM_MAP_VALUE(SMART_FLOW_CONTROL_REG)

#define GSW_ARL_TABLE_ACCESS_CONTROL_0     GSW_MEM_MAP_VALUE(ARL_TABLE_ACCESS_CONTROL_0_REG)
#define GSW_ARL_TABLE_ACCESS_CONTROL_1     GSW_MEM_MAP_VALUE(ARL_TABLE_ACCESS_CONTROL_1_REG)
#define GSW_ARL_TABLE_ACCESS_CONTROL_2     GSW_MEM_MAP_VALUE(ARL_TABLE_ACCESS_CONTROL_2_REG)

#define GSW_VLAN_PORT_PVID                 GSW_MEM_MAP_VALUE(VLAN_PORT_PVID_REG)

#define GSW_VLAN_VID_0_1                   GSW_MEM_MAP_VALUE(VLAN_VID_0_1_REG)
#define GSW_VLAN_VID_2_3                   GSW_MEM_MAP_VALUE(VLAN_VID_2_3_REG)
#define GSW_VLAN_VID_4_5                   GSW_MEM_MAP_VALUE(VLAN_VID_4_5_REG)
#define GSW_VLAN_VID_6_7                   GSW_MEM_MAP_VALUE(VLAN_VID_6_7_REG)

#define GSW_VLAN_MEMBER_PORT_MAP           GSW_MEM_MAP_VALUE(VLAN_MEMBER_PORT_MAP_REG)

#define GSW_VLAN_TAG_PORT_MAP              GSW_MEM_MAP_VALUE(VLAN_TAG_PORT_MAP_REG)

#define GSW_PPPOE_SESSION_ID_0_1           GSW_MEM_MAP_VALUE(PPPOE_SESSION_ID_0_1_REG)
#define GSW_PPPOE_SESSION_ID_2_3           GSW_MEM_MAP_VALUE(PPPOE_SESSION_ID_2_3_REG)
#define GSW_PPPOE_SESSION_ID_4_5           GSW_MEM_MAP_VALUE(PPPOE_SESSION_ID_4_5_REG)
#define GSW_PPPOE_SESSION_ID_6_7           GSW_MEM_MAP_VALUE(PPPOE_SESSION_ID_6_7_REG)

#define GSW_INTERRUPT_STATUS               GSW_MEM_MAP_VALUE(INTERRUPT_STATUS_REG)
#define GSW_INTERRUPT_MASK                 GSW_MEM_MAP_VALUE(INTERRUPT_MASK_REG)

#define GSW_PORT_MIRROR                    GSW_MEM_MAP_VALUE(PORT_MIRROR_REG)

#define GSW_BIST_RESULT_TEST_0             GSW_MEM_MAP_VALUE(BIST_RESULT_TEST_0_REG)
#define GSW_QUEUE_STATUS_TEST_1            GSW_MEM_MAP_VALUE(QUEUE_STATUS_TEST_1_REG)

#define GSW_ISP_TAGGING_PORT_CONFIG        GSW_MEM_MAP_VALUE(ISP_TAGGING_PORT_CONFIG_REG)

#define GSW_TS_DMA_CONTROL                 GSW_MEM_MAP_VALUE(TS_DMA_CONTROL_REG)
#define GSW_FS_DMA_CONTROL                 GSW_MEM_MAP_VALUE(FS_DMA_CONTROL_REG)
#define GSW_TS_DESCRIPTOR_POINTER          GSW_MEM_MAP_VALUE(TS_DESCRIPTOR_POINTER_REG)
#define GSW_FS_DESCRIPTOR_POINTER          GSW_MEM_MAP_VALUE(FS_DESCRIPTOR_POINTER_REG)
#define GSW_TS_DESCRIPTOR_BASE_ADDR        GSW_MEM_MAP_VALUE(TS_DESCRIPTOR_BASE_ADDR_REG)
#define GSW_FS_DESCRIPTOR_BASE_ADDR        GSW_MEM_MAP_VALUE(FS_DESCRIPTOR_BASE_ADDR_REG)

#define GSW_DELAYED_INTERRUPT_CONFIG       GSW_MEM_MAP_VALUE(DELAYED_INTERRUPT_CONFIG_REG)

#define GSW_HNAT_CONFIG                    GSW_MEM_MAP_VALUE(HNAT_CONFIG_REG)

#define GSW_HNAT_PRIVATE_IP_BASE           GSW_MEM_MAP_VALUE(HNAT_PRIVATE_IP_BASE_REG)

#define GSW_HNAT_DMAC_0_HIGH_ENTRY         GSW_MEM_MAP_VALUE(HNAT_DMAC_0_HIGH_ENTRY_REG)
#define GSW_HNAT_DMAC_0_LOW_ENTRY          GSW_MEM_MAP_VALUE(HNAT_DMAC_0_LOW_ENTRY_REG)

#define GSW_HNAT_DMAC_1_HIGH_ENTRY         GSW_MEM_MAP_VALUE(HNAT_DMAC_1_HIGH_ENTRY_REG)
#define GSW_HNAT_DMAC_1_LOW_ENTRY          GSW_MEM_MAP_VALUE(HNAT_DMAC_1_LOW_ENTRY_REG)

#define GSW_HNAT_DMAC_2_HIGH_ENTRY         GSW_MEM_MAP_VALUE(HNAT_DMAC_2_HIGH_ENTRY_REG)
#define GSW_HNAT_DMAC_2_LOW_ENTRY          GSW_MEM_MAP_VALUE(HNAT_DMAC_2_LOW_ENTRY_REG)

#define GSW_HNAT_DMAC_3_HIGH_ENTRY         GSW_MEM_MAP_VALUE(HNAT_DMAC_3_HIGH_ENTRY_REG)
#define GSW_HNAT_DMAC_3_LOW_ENTRY          GSW_MEM_MAP_VALUE(HNAT_DMAC_3_LOW_ENTRY_REG)

#define GSW_HNAT_FW_RULE_START_ADDR        GSW_MEM_MAP_VALUE(HNAT_FW_RULE_START_ADDR_REG)
#define GSW_HNAT_FW_RULE_END_ADDR          GSW_MEM_MAP_VALUE(HNAT_FW_RULE_END_ADDR_REG)

#define GSW_HNAT_FL_RULE_START_ADDR        GSW_MEM_MAP_VALUE(HNAT_FL_RULE_START_ADDR_REG)
#define GSW_HNAT_FL_RULE_END_ADDR          GSW_MEM_MAP_VALUE(HNAT_FL_RULE_END_ADDR_REG)

#define GSW_HNAT_ALG_START_ADDR            GSW_MEM_MAP_VALUE(HNAT_ALG_START_ADDR_REG)
#define GSW_HNAT_ALG_END_ADDR              GSW_MEM_MAP_VALUE(HNAT_ALG_END_ADDR_REG)

#define GSW_HNAT_SIP_BASE_ADDR             GSW_MEM_MAP_VALUE(HNAT_SIP_BASE_ADDR_REG)

#define GSW_HNAT_NAPT_BASE_ADDR            GSW_MEM_MAP_VALUE(HNAT_NAPT_BASE_ADDR_REG)

#define GSW_HNAT_NAPT_PORT_BASE            GSW_MEM_MAP_VALUE(HNAT_NAPT_PORT_BASE_REG)

#define GSW_HNAT_ARP_BASE_ADDR             GSW_MEM_MAP_VALUE(HNAT_ARP_BASE_ADDR_REG)

#define GSW_HNAT_TCP_SNA_THRESHOLD         GSW_MEM_MAP_VALUE(HNAT_TCP_SNA_THRESHOLD_REG)

#define GSW_HNAT_SOURCE_MAC_0_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_0_HIGH)

#define GSW_HNAT_SOURCE_MAC_0_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_0_LOW)

#define GSW_HNAT_SOURCE_MAC_1_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_1_HIGH)

#define GSW_HNAT_SOURCE_MAC_1_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_1_LOW)

#define GSW_HNAT_SOURCE_MAC_2_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_2_HIGH)

#define GSW_HNAT_SOURCE_MAC_2_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_2_LOW)

#define GSW_HNAT_SOURCE_MAC_3_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_3_HIGH)

#define GSW_HNAT_SOURCE_MAC_3_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_3_LOW)

#define GSW_HNAT_SOURCE_MAC_4_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_4_HIGH)

#define GSW_HNAT_SOURCE_MAC_4_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_4_LOW)

#define GSW_HNAT_SOURCE_MAC_5_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_5_HIGH)

#define GSW_HNAT_SOURCE_MAC_5_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_5_LOW)

#define GSW_HNAT_SOURCE_MAC_6_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_6_HIGH)

#define GSW_HNAT_SOURCE_MAC_6_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_6_LOW)

#define GSW_HNAT_SOURCE_MAC_7_HIGH	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_7_HIGH)

#define GSW_HNAT_SOURCE_MAC_7_LOW	   GSW_MEM_MAP_VALUE(HNAT_SOURCE_MAC_7_LOW)

#define GSW_HNAT_TCP_MSS_LIMIT	           GSW_MEM_MAP_VALUE(HNAT_TCP_MSS_LIMIT)

#define GSW_HNAT_AGING_CONFIG	           GSW_MEM_MAP_VALUE(HNAT_AGING_CONFIG)


/*
 * define constants macros
 */
#define GSW_MAX_VLAN_NUM                   (8)


/*
 * data structure defines
 */
typedef struct _VLAN_STRUCT_    VLAN_STRUCT_T;

struct _VLAN_STRUCT_
{
    unsigned int     vlan_gid;         /* 3-bit VLAN group ID */
    
    unsigned int     vlan_vid;         /* 12-bit VLAN ID */
    
    unsigned int     vlan_group;       /* 3-bit VLAN group port map */
    
    unsigned int     vlan_tag_flag;    /* 3-bit VLAN tag port map */
    
    unsigned char    vlan_mac[6];      /* VLAN MAC address */
    
    unsigned char    vlan_use_flag;
};


typedef struct _ARL_TABLE_ENTRY_    ARL_TABLE_ENTRY_T;

struct _ARL_TABLE_ENTRY_
{
    unsigned int     filter;
    
    unsigned int     vlan_mac;
    
    unsigned int     vlan_gid;
    
    unsigned int     age_field;
    
    unsigned int     port_map;
    
    unsigned char    mac_addr[6];
    
    unsigned char    pad[2];    
};


/*
 * GSW's TS_DMA data structure
 */
typedef struct _GSW_TS_INFO1_    GSW_TS_INFO1_T;

struct _GSW_TS_INFO1_
{
    unsigned int    seg_data_ptr;
};


typedef struct _GSW_TS_INFO2_    GSW_TS_INFO2_T;

struct _GSW_TS_INFO2_
{
    unsigned int    seg_data_len          : 16;
    unsigned int    tcp_checksum_offload  : 1;
    unsigned int    udp_checksum_offload  : 1;
    unsigned int    ip_checksum_offload   : 1;    
    unsigned int    force_route_port_map  : 3;
    unsigned int    force_route           : 1;
    unsigned int    force_priority_value  : 3;
    unsigned int    force_priority        : 1;
    unsigned int    interrupt_bit         : 1;
    unsigned int    last_seg              : 1;
    unsigned int    first_seg             : 1;
    unsigned int    end_bit               : 1;
    unsigned int    c_bit                 : 1;
};



typedef struct _GSW_TS_INFO3_    GSW_TS_INFO3_T;

struct _GSW_TS_INFO3_
{
    unsigned int    vid_index             : 3;
    unsigned int    insert_vid_tag        : 1;
    unsigned int    pppoe_section_index   : 3;
    unsigned int    insert_pppoe_section  : 1;
    unsigned int    wlan_tx_ctrl0         : 24;
};


typedef struct _GSW_TS_INFO4_    GSW_TS_INFO4_T;

struct _GSW_TS_INFO4_
{
    unsigned int    wlan_tx_ctrl1;
};


/* 
 * To Switch Transmit Frame Descriptor(TS_TFD) for GSW MAC frame
 * Note all TS_TFD must be aligned on 8-byte physical address boundaries
 */
typedef struct _GSW_TS_TFD_    GSW_TS_TFD_T;

struct _GSW_TS_TFD_
{
    GSW_TS_INFO1_T    ts_info1;
    
    GSW_TS_INFO2_T    ts_info2;
    
    GSW_TS_INFO3_T    ts_info3;
    
    GSW_TS_INFO4_T    ts_info4;    
};


/*
 * GSW's FS_DMA data structure
 */
typedef struct _GSW_FS_INFO1_    GSW_FS_INFO1_T;

struct _GSW_FS_INFO1_
{
    unsigned int    seg_data_ptr;
};


typedef struct _GSW_FS_INFO2_    GSW_FS_INFO2_T;

struct _GSW_FS_INFO2_
{
    unsigned int    seg_data_len          : 16;
    unsigned int    layer4_checksum_fail  : 1;
    unsigned int    ip_checksum_fail      : 1;
    unsigned int    protocol_value        : 2;    
    unsigned int    hnat_reason           : 6;
    unsigned int    source_port_value     : 2;    
    unsigned int    last_seg              : 1;
    unsigned int    first_seg             : 1;
    unsigned int    end_bit               : 1;
    unsigned int    c_bit                 : 1;
};


typedef struct _GSW_FS_INFO3_    GSW_FS_INFO3_T;

struct _GSW_FS_INFO3_
{
    unsigned int    wlan_rx_status0;
};


typedef struct _GSW_FS_INFO4_    GSW_FS_INFO4_T;

struct _GSW_FS_INFO4_
{
    unsigned int    wlan_rx_status1;
};


/* 
 * From Switch Receive Frame Descriptor(FS_RFD) for GSW MAC frame
 * Note all FS_RFD must be aligned on 8-byte physical address boundaries
 */
typedef struct _GSW_FS_RFD_    GSW_FS_RFD_T;

struct _GSW_FS_RFD_
{
    GSW_FS_INFO1_T    fs_info1;
    
    GSW_FS_INFO2_T    fs_info2;
    
    GSW_FS_INFO3_T    fs_info3;
    
    GSW_FS_INFO4_T    fs_info4;  
};



typedef struct _DMA_ENTITY_    DMA_ENTITY_T;

struct _DMA_ENTITY_
{
    unsigned int    tssd;

    unsigned int    fssd;

    unsigned int    ts_base;

    unsigned int    fs_base;

    unsigned int    delayed_interrupt_use_flag;

    unsigned int    max_pending_fsrc_int_num;
    
    unsigned int    max_pending_time;
};


/*
 * GSW data structure
 */
typedef struct _GSW_OBJECT_    GSW_OBJECT_T;

struct _GSW_OBJECT_
{
    /* 
     * For Switch/MAC Port0/1 and CPU Port setting
     */
    unsigned int     switch_config;

    unsigned int     mac_port0_config;

    unsigned int     mac_port1_config;
    
    unsigned int     cpu_port_config;


    /* 
     * For VLAN and Port-based VLAN setting
     */
    VLAN_STRUCT_T    vlan[8];
    
    unsigned int     mac_port0_pvid;
    
    unsigned int     mac_port1_pvid;
    
    unsigned int     cpu_port_pvid;


    /* 
     * For DMA entity setting
     */
    DMA_ENTITY_T     dma;


    /* 
     * For interrupt setting
     */
    unsigned int     interrupt_use_flag;
};


/*
 * end of data structure defines
 */


#if 0
/*
 * functions declarations
 */
extern void       Hal_Gsw_Reset(void);

extern u_int32    Hal_Gsw_Initialize(GSW_OBJECT_T *);

u_int32    Hal_Gsw_Write_PHY(u_int32, u_int32, u_int16);

u_int32    Hal_Gsw_Read_PHY(u_int32, u_int32, u_int16 *);

void       Hal_Gsw_Write_IP_TOS_Priority(u_int32, u_int32);

int        Hal_Gsw_Search_ARL_Table_Entry(u_int32);

int        Hal_Gsw_Find_ARL_Table_Valid_Entry_Num(void);

u_int32    Hal_Gsw_Write_ARL_Table_Entry(ARL_TABLE_ENTRY_T *);

u_int32    Hal_Gsw_Lookup_ARL_Table_Entry(ARL_TABLE_ENTRY_T *);
#endif





/*
 * macro declarations
 */
/*
 * GSW macros defines
 */
#define HAL_GSW_WRITE_SWITCH_CONFIGURATION(config_value)	((GSW_SWITCH_CONFIG) = (config_value))


#define HAL_GSW_READ_SWITCH_CONFIGURATION(config_value)		((config_value) = (GSW_SWITCH_CONFIG))


#define HAL_GSW_DISABLE_HNAT()	((GSW_SWITCH_CONFIG) &= ~(0x1 << 23))


#define HAL_GSW_ENABLE_HNAT()	((GSW_SWITCH_CONFIG) |= (0x1 << 23))


#define HAL_GSW_WRITE_MAC_PORT0_CONFIGURATION(config_value)	((GSW_MAC_PORT_0_CONFIG) = (config_value))


#define HAL_GSW_READ_MAC_PORT0_CONFIGURATION(config_value)	((config_value) = (GSW_MAC_PORT_0_CONFIG))


#define HAL_GSW_WRITE_MAC_PORT1_CONFIGURATION(config_value)	((GSW_MAC_PORT_1_CONFIG) = (config_value))


#define HAL_GSW_READ_MAC_PORT1_CONFIGURATION(config_value)	((config_value) = (GSW_MAC_PORT_1_CONFIG))


#define HAL_GSW_WRITE_CPU_PORT_CONFIGURATION(config_value)	((GSW_CPU_PORT_CONFIG) = (config_value))


#define HAL_GSW_READ_CPU_PORT_CONFIGURATION(config_value)	((config_value) = (GSW_CPU_PORT_CONFIG))


#define HAL_GSW_WRITE_PRIORITY_CONTROL(control_value)		((GSW_PRIORITY_CONTROL) = (control_value))


#define HAL_GSW_READ_PRIORITY_CONTROL(control_value)		((control_value) = (GSW_PRIORITY_CONTROL))


#define HAL_GSW_WRITE_UDP_PRIORITY_PORT(udp_port)		((GSW_UDP_PRIORITY) = (udp_port & 0xFFFF))


#define HAL_GSW_READ_UDP_PRIORITY_PORT(udp_port)		((udp_port) = (GSW_UDP_PRIORITY & 0xFFFF))


#define HAL_GSW_WRITE_SCHEDULING_CONTROL(scheduling_control)	((GSW_SCHEDULER_CONTROL) = (scheduling_control))


#define HAL_GSW_READ_SCHEDULING_CONTROL(scheduling_control)	((scheduling_control) = (GSW_SCHEDULER_CONTROL))


#define HAL_GSW_WRITE_RATE_LIMIT_CONTROL(rate_limit_control)	((GSW_RATE_LIMIT_CONTROL) = (rate_limit_control))


#define HAL_GSW_READ_RATE_LIMIT_CONTROL(rate_limit_control)	((rate_limit_control) = (GSW_RATE_LIMIT_CONTROL))


#define HAL_GSW_WRITE_FLOW_CONTROL_GLOBAL_THRESHOLD(fc_global_threshold)	((GSW_FLOW_CONTROL_GLOBAL_THRESHOLD) = (fc_global_threshold))


#define HAL_GSW_READ_FLOW_CONTROL_GLOBAL_THRESHOLD(fc_global_threshold)		((fc_global_threshold) = (GSW_FLOW_CONTROL_GLOBAL_THRESHOLD))


#define HAL_GSW_WRITE_FLOW_CONTROL_PORT_THRESHOLD(fc_port_threshold)		((GSW_FLOW_CONTROL_PORT_THRESHOLD) = (fc_port_threshold))


#define HAL_GSW_READ_FLOW_CONTROL_PORT_THRESHOLD(fc_port_threshold)		((fc_port_threshold) = (GSW_FLOW_CONTROL_PORT_THRESHOLD))


#define HAL_GSW_WRITE_SMART_FLOW_CONTROL(smart_fc)		((GSW_SMART_FLOW_CONTROL) = (smart_fc))


#define HAL_GSW_READ_SMART_FLOW_CONTROL(smart_fc)		((smart_fc) = (GSW_SMART_FLOW_CONTROL))


#define HAL_GSW_SET_MAC_PORT0_PVID(port0_pvid)	{ ((GSW_VLAN_PORT_PVID) &= (~(0x7 << 0))); ((GSW_VLAN_PORT_PVID) |= ((port0_pvid) & 0x7)); }


#define HAL_GSW_SET_MAC_PORT1_PVID(port1_pvid)	{ ((GSW_VLAN_PORT_PVID) &= (~(0x7 << 4))); ((GSW_VLAN_PORT_PVID) |= (((port1_pvid) & 0x7) << 4)); }


#define HAL_GSW_SET_CPU_PORT_PVID(cpu_port_pvid) { ((GSW_VLAN_PORT_PVID) &= (~(0x7 << 8))); ((GSW_VLAN_PORT_PVID) |= (((cpu_port_pvid) & 0x7) << 8)); }

    
#define HAL_GSW_SET_VLAN_0_VID(vid)	{ ((GSW_VLAN_VID_0_1) &= (~(0xFFF << 0))); ((GSW_VLAN_VID_0_1) |= (((vid) & 0xFFF) << 0)); }


#define HAL_GSW_SET_VLAN_1_VID(vid)	{ ((GSW_VLAN_VID_0_1) &= (~(0xFFF << 12))); ((GSW_VLAN_VID_0_1) |= (((vid) & 0xFFF) << 12)); }


#define HAL_GSW_SET_VLAN_2_VID(vid)	{ ((GSW_VLAN_VID_2_3) &= (~(0xFFF << 0))); ((GSW_VLAN_VID_2_3) |= (((vid) & 0xFFF) << 0)); }


#define HAL_GSW_SET_VLAN_3_VID(vid)	{ ((GSW_VLAN_VID_2_3) &= (~(0xFFF << 12))); ((GSW_VLAN_VID_2_3) |= (((vid) & 0xFFF) << 12)); }


#define HAL_GSW_SET_VLAN_4_VID(vid)	{ ((GSW_VLAN_VID_4_5) &= (~(0xFFF << 0))); ((GSW_VLAN_VID_4_5) |= (((vid) & 0xFFF) << 0)); }


#define HAL_GSW_SET_VLAN_5_VID(vid)	{ ((GSW_VLAN_VID_4_5) &= (~(0xFFF << 12))); ((GSW_VLAN_VID_4_5) |= (((vid) & 0xFFF) << 12)); }


#define HAL_GSW_SET_VLAN_6_VID(vid)	{ ((GSW_VLAN_VID_6_7) &= (~(0xFFF << 0))); ((GSW_VLAN_VID_6_7) |= (((vid) & 0xFFF) << 0)); }


#define HAL_GSW_SET_VLAN_7_VID(vid) 	{ ((GSW_VLAN_VID_6_7) &= (~(0xFFF << 12))); ((GSW_VLAN_VID_6_7) |= (((vid) & 0xFFF) << 12)); }


#define HAL_GSW_SET_VLAN_0_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 0))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 0)); }


#define HAL_GSW_SET_VLAN_1_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 3))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 3)); }


#define HAL_GSW_SET_VLAN_2_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 6))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 6)); }


#define HAL_GSW_SET_VLAN_3_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 9))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 9)); }


#define HAL_GSW_SET_VLAN_4_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 12))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 12)); }


#define HAL_GSW_SET_VLAN_5_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 15))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 15)); }


#define HAL_GSW_SET_VLAN_6_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 18))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 18)); }


#define HAL_GSW_SET_VLAN_7_MEMBER(vlan_member)	{ ((GSW_VLAN_MEMBER_PORT_MAP) &= (~(0x7 << 21))); ((GSW_VLAN_MEMBER_PORT_MAP) |= (((vlan_member) & 0x7) << 21)); }


#define HAL_GSW_SET_VLAN_0_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 0))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 0)); }


#define HAL_GSW_SET_VLAN_1_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 3))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 3)); }


#define HAL_GSW_SET_VLAN_2_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 6))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 6)); }


#define HAL_GSW_SET_VLAN_3_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 9))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 9)); }


#define HAL_GSW_SET_VLAN_4_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 12))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 12)); }


#define HAL_GSW_SET_VLAN_5_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 15))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 15)); }


#define HAL_GSW_SET_VLAN_6_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 18))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 18)); }


#define HAL_GSW_SET_VLAN_7_TAG(vlan_tag)	{ ((GSW_VLAN_TAG_PORT_MAP) &= (~(0x7 << 21))); ((GSW_VLAN_TAG_PORT_MAP) |= (((vlan_tag) & 0x7) << 21)); }


#define HAL_GSW_SET_PPPOE_SESSION_0_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_0_1) &= (~(0xFFFF << 0))); ((GSW_PPPOE_SESSION_ID_0_1) |= (((session_id) & 0xFFFF) << 0)); }


#define HAL_GSW_SET_PPPOE_SESSION_1_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_0_1) &= (~((unsigned int)0xFFFF << 16))); ((GSW_PPPOE_SESSION_ID_0_1) |= (((session_id) & 0xFFFF) << 16)); }


#define HAL_GSW_SET_PPPOE_SESSION_2_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_2_3) &= (~(0xFFFF << 0))); ((GSW_PPPOE_SESSION_ID_2_3) |= (((session_id) & 0xFFFF) << 0)); }


#define HAL_GSW_SET_PPPOE_SESSION_3_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_2_3) &= (~((unsigned int)0xFFFF << 16))); ((GSW_PPPOE_SESSION_ID_2_3) |= (((session_id) & 0xFFFF) << 16)); }
    

#define HAL_GSW_SET_PPPOE_SESSION_4_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_4_5) &= (~(0xFFFF << 0))); ((GSW_PPPOE_SESSION_ID_4_5) |= (((session_id) & 0xFFFF) << 0)); }


#define HAL_GSW_SET_PPPOE_SESSION_5_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_4_5) &= (~((unsigned int)0xFFFF << 16))); ((GSW_PPPOE_SESSION_ID_4_5) |= (((session_id) & 0xFFFF) << 16)); }


#define HAL_GSW_SET_PPPOE_SESSION_6_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_6_7) &= (~(0xFFFF << 0))); ((GSW_PPPOE_SESSION_ID_6_7) |= (((session_id) & 0xFFFF) << 0)); }


#define HAL_GSW_SET_PPPOE_SESSION_7_ID(session_id)	{ ((GSW_PPPOE_SESSION_ID_6_7) &= (~((unsigned int)0xFFFF << 16))); ((GSW_PPPOE_SESSION_ID_6_7) |= (((session_id) & 0xFFFF) << 16)); }


#define HAL_GSW_READ_INTERRUPT_STATUS(int_status)	((int_status) = (GSW_INTERRUPT_STATUS))


#define HAL_GSW_CLEAR_ALL_INTERRUPT_STATUS_SOURCES()	((GSW_INTERRUPT_STATUS) = (0xFFFF1FFF))


#define HAL_GSW_CLEAR_INTERRUPT_STATUS_SOURCES(source)	((GSW_INTERRUPT_STATUS) |= (source))


#define HAL_GSW_CLEAR_INTERRUPT_STATUS_SOURCE_BIT(source_bit_index)	((GSW_INTERRUPT_STATUS) |= (1 << (source_bit_index)))
    

#define HAL_GSW_DISABLE_ALL_INTERRUPT_STATUS_SOURCES()			((GSW_INTERRUPT_MASK) = (0xFFFF1FFF))


#define HAL_GSW_ENABLE_ALL_INTERRUPT_STATUS_SOURCES()			((GSW_INTERRUPT_MASK) = (0x00000000))


#define HAL_GSW_DISABLE_INTERRUPT_STATUS_SOURCE_BIT(source_bit_index)	((GSW_INTERRUPT_MASK) |= (1 << (source_bit_index)))


#define HAL_GSW_ENABLE_INTERRUPT_STATUS_SOURCE_BIT(source_bit_index)	((GSW_INTERRUPT_MASK) &= ~(1 << (source_bit_index))) 


#define HAL_GSW_WRITE_PORT_MIRROR(port_mirror)				((GSW_PORT_MIRROR) = (port_mirror))


#define HAL_GSW_READ_PORT_MIRROR(port_mirror)				((port_mirror) = (GSW_PORT_MIRROR))


#define HAL_GSW_WRITE_ISP_TAGGING_PORT_CONFIG(isp_tagging_port_config)	((GSW_ISP_TAGGING_PORT_CONFIG) = (isp_tagging_port_config & 0x7))


#define HAL_GSW_READ_ISP_TAGGING_PORT_CONFIG(isp_tagging_port_config)	((isp_tagging_port_config) = (GSW_ISP_TAGGING_PORT_CONFIG & 0x7))



/*
 * GSW's DMA macros defines
 */
#define HAL_GSW_TS_DMA_START()			((GSW_TS_DMA_CONTROL) = (1))
    

#define HAL_GSW_TS_DMA_STOP()			((GSW_TS_DMA_CONTROL) = (0))


#define HAL_GSW_READ_TS_DMA_STATE(state)	((state) = (GSW_TS_DMA_CONTROL))

    
#define HAL_GSW_FS_DMA_START()			((GSW_FS_DMA_CONTROL) = (1))
    

#define HAL_GSW_FS_DMA_STOP()			((GSW_FS_DMA_CONTROL) = (0))


#define HAL_GSW_WRITE_TSSD(tssd_value)		((GSW_TS_DESCRIPTOR_POINTER) = (tssd_value))
    

#define HAL_GSW_READ_TSSD(tssd_value)		((tssd_value) = (GSW_TS_DESCRIPTOR_POINTER))


#define HAL_GSW_WRITE_FSSD(fssd_value)		((GSW_FS_DESCRIPTOR_POINTER) = (fssd_value))
    

#define HAL_GSW_READ_FSSD(fssd_value)		((fssd_value) = (GSW_FS_DESCRIPTOR_POINTER))


#define HAL_GSW_WRITE_TS_BASE(ts_base_value)	((GSW_TS_DESCRIPTOR_BASE_ADDR) = (ts_base_value))

    
#define HAL_GSW_READ_TS_BASE(ts_base_value)	((ts_base_value) = (GSW_TS_DESCRIPTOR_BASE_ADDR))


#define HAL_GSW_WRITE_FS_BASE(fs_base_value)	((GSW_FS_DESCRIPTOR_BASE_ADDR) = (fs_base_value))

 
#define HAL_GSW_READ_FS_BASE(fs_base_value)	((fs_base_value) = (GSW_FS_DESCRIPTOR_BASE_ADDR))


#define HAL_GSW_WRITE_DELAYED_INTERRUPT_CONFIG(delayed_interrupt_config)	((GSW_DELAYED_INTERRUPT_CONFIG) = (delayed_interrupt_config))


#define HAL_GSW_READ_DELAYED_INTERRUPT_CONFIG(delayed_interrupt_config)		((delayed_interrupt_config) = (GSW_DELAYED_INTERRUPT_CONFIG))





/*
 * ================================================================================
 */
#define ORN_APB_DEV_BASE			0x70000000


/* Power Management Base Address */
#define ORN_PWR_MNG_BASE			(ORN_APB_DEV_BASE + 0x07000000)

/* Power Management Offset */
#define PWR_CLK_MSK_REG				(ORN_PWR_MNG_BASE + 0x00)
#define PWR_SOFT_RST_REG			(ORN_PWR_MNG_BASE + 0x04)
#define PWR_SYS_CLK_REG				(ORN_PWR_MNG_BASE + 0x08)
#define PWR_CPU_INIT_REG			(ORN_PWR_MNG_BASE + 0x0C)
#define PWR_PLL_DWN_REG				(ORN_PWR_MNG_BASE + 0x10)
#define PWR_RST_CFG_REG                 	(ORN_PWR_MNG_BASE + 0x14)
#define PWR_RGLR_REG              		(ORN_PWR_MNG_BASE + 0x18)
#define PWR_PAD_DRV_REG                 	(ORN_PWR_MNG_BASE + 0x1C)
#define PWR_SOFT_BND_CHK_REG            	(ORN_PWR_MNG_BASE + 0x20)
#define PWR_IDP_FUNC_CHK_REG            	(ORN_PWR_MNG_BASE + 0x24)

/* Power Management Registers */

/* Power Management Clock Mask Register */
#define PWR_CLK_GSW_DIS                   	(1 << 4)

/* Power Management Software Reset Register */
#define PWR_SOFT_RST_GSW                  	(1 << 4)

/* Power Management PLL Power Down Register */
#define PWR_PLL_125_DWN                   	(1 << 0)




/* Gigabit Switch Base Address													*/
#define ORN_GSW_BASE				(ORN_APB_DEV_BASE + 0x00000000)

/* Gigabit Switch Register Offset */
#define GSW_PHY_CTL_REG				(ORN_GSW_BASE + 0x000)
#define GSW_CFG_REG				(ORN_GSW_BASE + 0x004)
#define GSW_PORT0_CFG_REG			(ORN_GSW_BASE + 0x008)
#define GSW_PORT1_CFG_REG			(ORN_GSW_BASE + 0x00C)
#define GSW_CPU_PORT_CFG_REG			(ORN_GSW_BASE + 0x010)

/* Gigabit Switch Priority Offset */
#define GSW_PRI_CTL_REG				(ORN_GSW_BASE + 0x014
#define GSW_UDP_PRI_CTL_REG			(ORN_GSW_BASE + 0x018

/* Gigabit Switch IP TOS Offset	*/
#define GSW_IP_TOS_0_7_PRI_REG			(ORN_GSW_BASE + 0x01C)
#define GSW_IP_TOS_8_15_PRI_REG			(ORN_GSW_BASE + 0x020)
#define GSW_IP_TOS_16_23_PRI_REG		(ORN_GSW_BASE + 0x024)
#define GSW_IP_TOS_24_31_PRI_REG		(ORN_GSW_BASE + 0x028)
#define GSW_IP_TOS_32_39_PRI_REG		(ORN_GSW_BASE + 0x02C)
#define GSW_IP_TOS_40_47_PRI_REG		(ORN_GSW_BASE + 0x030)
#define GSW_IP_TOS_48_55_PRI_REG		(ORN_GSW_BASE + 0x034)
#define GSW_IP_TOS_56_63_PRI_REG		(ORN_GSW_BASE + 0x038)

/* Gigabit Switch Sechdule control Offset */
#define GSW_SECH_CTL_REG			(ORN_GSW_BASE + 0x03C)

/*Gigabit Switch Rate Limit Control Offset */
#define GSW_RATE_LMT_CTL_REG			(ORN_GSW_BASE + 0x040)

/* Gigabit Switch Flow Control Offset */
#define GSW_FLW_CTL_GLB_THRSHD			(ORN_GSW_BASE + 0x044)
#define GSW_FLW_CTL_PORT_THRSHD			(ORN_GSW_BASE + 0x048)
#define GSW_SMART_FLW_CTL_REG			(ORN_GSW_BASE + 0x04C)

/* Gigabit Switch ARL Table Access Control Offset */
#define GSW_ARL_TBL_ACCTL_0_REG			(ORN_GSW_BASE + 0x050)
#define GSW_ARL_TBL_ACCTL_1_REG			(ORN_GSW_BASE + 0x054)
#define GSW_ARL_TBL_ACCTL_2_REG			(ORN_GSW_BASE + 0x058)

/* Gigabit Switch VLAN Offset */
#define GSW_VLAN_PVID_REG			(ORN_GSW_BASE + 0x05C)
#define GSW_VLAN_VID_0_1_REG			(ORN_GSW_BASE + 0x060)
#define GSW_VLAN_VID_0_1_REG			(ORN_GSW_BASE + 0x060)
#define GSW_VLAN_VID_2_3_REG			(ORN_GSW_BASE + 0x064)
#define GSW_VLAN_VID_4_5_REG			(ORN_GSW_BASE + 0x068)
#define GSW_VLAN_VID_6_7_REG			(ORN_GSW_BASE + 0x06C)
#define GSW_VLAN_MBR_PMAP_REG			(ORN_GSW_BASE + 0x070)
#define GSW_VLAN_TAG_PMAP_REG			(ORN_GSW_BASE + 0x074)

/* Gigabit Switch PPPOE Session Offset */
#define GSW_PPOE_SESN_ID_0_1_REG		(ORN_GSW_BASE + 0x078)
#define GSW_PPOE_SESN_ID_2_3_REG		(ORN_GSW_BASE + 0x07C)
#define GSW_PPOE_SESN_ID_4_5_REG		(ORN_GSW_BASE + 0x080)
#define GSW_PPOE_SESN_ID_6_7_REG		(ORN_GSW_BASE + 0x084)

/* Gigabit Switch Interrupt Offset */
#define GSW_INT_STAT_REG			(ORN_GSW_BASE + 0x088)
#define GSW_INT_MSK_REG				(ORN_GSW_BASE + 0x08C)

/* Gigabit Switch Port Mirror Offset */
#define GSW_PORT_MIRR_REG			(ORN_GSW_BASE + 0x090)

/* Gigabit Switch BIST and Queue Status Offset */
#define GSW_BIST_RSLT_TST_0_REG			(ORN_GSW_BASE + 0x094)
#define GSW_Q_STAT_TST_1_REG			(ORN_GSW_BASE + 0x098)

/* Gigabit Switch DMA Offset */
#define GSW_TS_DMA_CTL_REG			(ORN_GSW_BASE + 0x100)
#define GSW_FS_DMA_CTL_REG			(ORN_GSW_BASE + 0x104)
#define GSW_TS_DESC_PTR_REG			(ORN_GSW_BASE + 0x108)
#define GSW_FS_DESC_PTR_REG			(ORN_GSW_BASE + 0x10C)
#define GSW_TS_DESC_BASE_ADDR			(ORN_GSW_BASE + 0x110)
#define GSW_FS_DESC_BASE_ADDR			(ORN_GSW_BASE + 0x114)



/* Gigabit Switch Registers */

/* Gigabit Switch PHY control Register */
#define GSW_PHY_CTL_PHY_ADDR_MSK      0x1

#define GSW_PHY_CTL_PHY_REG           8
#define GSW_PHY_CTL_PHY_REG_MSK       0xf

#define GSW_PHY_CTL_CMD_WRITE         (1 << 13)
#define GSW_PHY_CTL_CMD_READ          (1 << 14)

#define GSW_PHY_CTL_CMD_DONE          (1 << 15)

#define GSW_PHY_CTL_PHY_DATA          16
#define GSW_PHY_CTL_PHY_DATA_MSK      0xffff

/* Gigabit Switch Configuration Register */
#define GSW_CFG_AGE_TIME_MSK          0xf
#define GSW_CFG_AGE_FAST_MODE         0xf

#define GSW_CFG_MAX_LEN               4
#define GSW_CFG_MAX_LEN_MSK           (0x3 << GSW_CFG_MAX_LEN)
#define GSW_CFG_MAX_LEN_1518          (0 << GSW_CFG_MAX_LEN)
#define GSW_CFG_MAX_LEN_1522          (1 << GSW_CFG_MAX_LEN)
#define GSW_CFG_MAX_LEN_1536          (2 << GSW_CFG_MAX_LEN)
#define GSW_CFG_MAX_LEN_JMBO          (3 << GSW_CFG_MAX_LEN)


#define GSW_CFG_HASH_MODE             6
#define GSW_CFG_HASH_MSK              (0x3 << GSW_CFG_HASH_MODE)
#define GSW_CFG_HASH_DIRECT           (0 << GSW_CFG_HASH_MODE)
#define GSW_CFG_HASH_XOR48            (1 << GSW_CFG_HASH_MODE)
#define GSW_CFG_HASH_XOR32            (2 << GSW_CFG_HASH_MODE)

#define GSW_CFG_BACK_OFF_MODE         8
#define GSW_CFG_BACK_OFF_MSK          (0x7 << GSW_CFG_BACK_OFF_MODE)
#define GSW_CFG_BACK_OFF_IMDLY        (0 << GSW_CFG_BACK_OFF_MODE)
#define GSW_CFG_BACK_OFF_N(_x)        (((_x) << GSW_CFG_BACK_OFF_MODE) & GSW_CFG_BACK_OFF_MSK)
#define GSW_CFG_BACK_OFF_STD          (7 << GSW_CFG_BACK_OFF_MODE)

#define GSW_CFG_JAM_NO                12
#define GSW_CFG_JAM_NO_MSK            (0xf << GSW_CFG_JAM_NO)
#define GSW_CFG_JAM_NUM(_x)           (((_x) << GSW_CFG_JAM_NO) & GSW_CFG_JAM_NO_MSK)

#define GSW_CFG_BP_MODE               16
#define GSW_CFG_BP_MSK                (0x3 << GSW_CFG_BP_MODE)
#define GSW_CFG_BP_DIS                (0 << GSW_CFG_BP_MODE)
#define GSW_CFG_BP_SMART              (1 << GSW_CFG_BP_MODE)
#define GSW_CFG_BP_ALL                (2 << GSW_CFG_BP_MODE)
#define GSW_CFG_BP_FORCE              (3 << GSW_CFG_BP_MODE)

#define GSW_CFG_RSV_MC_FLT            (1 << 18)

#define GSW_CFG_COL_MODE              19
#define GSW_CFG_COL_MSK               (0x3 << GSW_CFG_COL_MODE)
#define GSW_CFG_COL_NVR_DRP           (0 << GSW_CFG_COL_MODE)
#define GSW_CFG_COL_LMT_1             (1 << GSW_CFG_COL_MODE)
#define GSW_CFG_COL_LMT_2             (2 << GSW_CFG_COL_MODE)
#define GSW_CFG_COL_LMT_16            (3 << GSW_CFG_COL_MODE)

#define GSW_CFG_CRC_STRP              (1 << 21)

#define GSW_CFG_IVL                   (1 << 22)

#define GSW_CFG_HNAT_EN               (1 << 23)

#define GSW_CFG_FWALL_MODE            (1 << 24)

#define GSW_CFG_SKIP_L2_LKUP          28
#define GSW_CFG_SKIP_L2_LKUP_MSK      (0x3 << GSW_CFG_SKIP_L2_LKUP)
#define GSW_CFG_SKIP_L2_LKUP_P1       (1 << GSW_CFG_SKIP_L2_LKUP)
#define GSW_CFG_SKIP_L2_LKUP_P2       (2 << GSW_CFG_SKIP_L2_LKUP)

#define GSW_CFG_NIC_MODE              (1 << 30)


/* Gigabit Switch MAC Port Configuration Registers */
#define GSW_PORT_LNK_UP               (1 << 0)

#define GSW_PORT_TX_CLK_ERR           (1 << 1)

#define GSW_PORT_SPD_STAT             2
#define GSW_PORT_SPD_MSK              (0x3 << GSW_PORT_SPD_STAT)
#define GSW_PORT_SPD_10M              (0 << GSW_PORT_SPD_STAT)
#define GSW_PORT_SPD_100M             (1 << GSW_PORT_SPD_STAT)
#define GSW_PORT_SPD_1000M            (2 << GSW_PORT_SPD_STAT)

#define GSW_PORT_FULL_DPLX            (1 << 4)

#define GSW_PORT_RX_FLOW_CTL          (1 << 5)

#define GSW_PORT_TX_FLOW_CTL          (1 << 6)

#define GSW_PORT_AUTO_NEG_EN          (1 << 7)

#define GSW_PORT_FORCE_SPD            8
#define GSW_PORT_FORCE_SPD_MSK        (0x3 << GSW_PORT_FORCE_SPD)
#define GSW_PORT_FORCE_10M            (0 << GSW_PORT_FORCE_SPD)
#define GSW_PORT_FORCE_100M           (1 << GSW_PORT_FORCE_SPD)
#define GSW_PORT_FORCE_1000M          (2 << GSW_PORT_FORCE_SPD)

#define GSW_PORT_FORCE_RX_FLOW        (1 << 11)

#define GSW_PORT_FORCE_TX_FLOW        (1 << 12)

#define GSW_PORT_TX_CLK_CHK_EN        (1 << 13)

#define GSW_PORT_RSV_MII_MODE         (1 << 14)

#define GSW_PORT_RGMII_PHY            (1 << 15)

#define GSW_PORT_WAS_TX_DIS           (1 << 16)

#define GSW_PORT_BP_EN                (1 << 17)

#define GSW_PORT_DIS                  (1 << 18)

#define GSW_PORT_SA_LRN_DIS           (1 << 19)

#define GSW_PORT_BLK_STAT             (1 << 20)

#define GSW_PORT_FWD_CTL_ONLY         (1 << 21)

#define GSW_PORT_AGE_EN               (1 << 22)

#define GSW_PORT_SA_SECURE            (1 << 23)

#define GSW_PORT_INGRESS_CHK          (1 << 24)

#define GSW_PORT_FWD_UNK_DIS          (1 << 25)

#define GSW_PORT_FWD_MC_DIS           (1 << 26)

#define GSW_PORT_FWD_BC_DIS           (1 << 27)

#define GSW_PORT_UC_PAUSE_DIS         (1 << 28)

#define GSW_PORT_BCS_UNK_EN           (1 << 29)

#define GSW_PORT_BCS_MC_EN            (1 << 30)

#define GSW_PORT_BCS_BC_EN            (1 << 31)


/* Gigabit Switch CPU Port configuration register  */
#define GSW_CPU_PORT_DIS              (1 << 18)

#define GSW_CPU_PORT_SA_LRN_DIS       (1 << 19)

#define GSW_CPU_PORT_AGE_EN           (1 << 22)

#define GSW_CPU_PORT_SA_SECURE        (1 << 23)

#define GSW_CPU_PORT_INGRESS_CHK      (1 << 24)

#define GSW_CPU_PORT_FLOW_CTL_EN      (1 << 31)


/* Gigabit Switch Port VLAN ID Registers */
#define GSW_VLAN_PVID_0               0
#define GSW_VLAN_PVID_1               4
#define GSW_VLAN_PVID_CPU             8

#define GSW_VLAN_PVID_MSK(port)         (0x7 << GSW_VLAN_PVID_##port)
#define GSW_VLAN_PVID(port, vid)        (((vid) << GSW_VLAN_PVID_##port) & GSW_VLAN_PVID_MSK(port))


/* Gigabit Switch VLAN Group ID Registers */
#define GSW_VLAN_ID(_x)                 (((_x) % 2) ? 12 : 0)
#define GSW_VLAN_ID_MSK(_x)             (0xfff << GSW_VLAN_ID(_x))


/* Gigabit Switch VLAN Port & Tag Map Registers */
#define GSW_VLAN_PORT_0                 (1 << 0)
#define GSW_VLAN_PORT_1                 (1 << 1)
#define GSW_VLAN_PORT_CPU               (1 << 2)
#define GSW_VLAN_PORT_MSK               0x7

#define GSW_VLAN_GROUP(_x)              ((_x) * 3)
#define GSW_VLAN_GROUP_MSK(_x)          (0x7 << GSW_VLAN_GROUP(_x))

#define GSW_VLAN_PORT_MAP(group, port)  ((port << GSW_VLAN_GROUP(group)) & GSW_VLAN_GROUP_MSK(group))

/* Gigabit Switch Interrupt Registers */
#define GSW_INT_MSK_ALL                 0xffff1fff


/* Gigabit Switch DMA Registers */
#define GSW_DMA_DIS                     0
#define GSW_DMA_EN                      1


/* Gigabit Switch ARL Table Registers */
/* GSW_ARL_TBL_ACCTL_0_REG */
#define GSW_ARL_CMD_SRCH_STRT           (1 << 0)
#define GSW_ARL_CMD_SRCH_AGAN           (1 << 1)
#define GSW_ARL_CMD_LKUP                (1 << 2)
#define GSW_ARL_CMD_WRITE               (1 << 3)

/* GSW_ARL_TBL_ACCTL_1_REG */
#define GSW_ARL_CMD_CMPLT               (1 << 0)
#define GSW_ARL_TBL_END                 (1 << 1)
#define GSW_ARL_LKUP_MCH                (1 << 2)
#define GSW_ARL_FLTR                    (1 << 3)
#define GSW_ARL_VLAN_MAC                (1 << 4)
#define GSW_ARL_VLAN_ID                 5
#define GSW_ARL_VLAN_ID_MSK             (0x7 << GSW_ARL_VLAN_ID)
#define GSW_ARL_AGE_FLD                 8
#define GSW_ARL_AGE_FLD_MSK             (0x7 << GSW_ARL_VLAN_ID)
#define GSW_ARL_PORT_MAP                11
#define GSW_ARL_PORT_MAP_MSK            (0x7 << GSW_ARL_PORT_MAP)
#define GSW_ARL_MAC_LO                  16
#define GSW_ARL_MAC_LO_MSK              (0xffff << GSW_ARL_MAC_LO)

/* GSW_ARL_TBL_ACCTL_2_REG */
#define GSW_ARL_MAC_HI_MSK              0xffffffff



/* Interrupt Control Base Address												*/
#define ORN_INT_CTL_BASE		(ORN_APB_DEV_BASE + 0x0D000000)\

#define INT_SRC_REG			(ORN_INT_CTL_BASE + 0x00)
#define INT_MSK_REG			(ORN_INT_CTL_BASE + 0x04)
#define INT_CLR_REG			(ORN_INT_CTL_BASE + 0x08)
#define INT_TRGR_MODE_REG		(ORN_INT_CTL_BASE + 0x0C)
#define INT_TRGR_LVL_REG		(ORN_INT_CTL_BASE + 0x10)
#define INT_STAT_REG			(ORN_INT_CTL_BASE + 0x14)
#define INT_FIQ_MODE_SEL_REG		(ORN_INT_CTL_BASE + 0x18)
#define INT_SFT_INT_REG			(ORN_INT_CTL_BASE + 0x1C)


/* Interrupts Registers */
#define INT_TIMER1                        (1 << 0)
#define INT_TIMER2                        (1 << 1)
#define INT_CLK_SCALE                     (1 << 2)
#define INT_WDG_TIMER                     (1 << 3)
#define INT_GPIO_EXT                      (1 << 4)
#define INT_RTC_SEC                       (1 << 5)
#define INT_RTC_MIN                       (1 << 6)
#define INT_RTC_HOUR                      (1 << 7)
#define INT_RTC_DAY                       (1 << 8)
#define INT_RTC_MATCH                     (1 << 9)
#define INT_UART                          (1 << 10)
#define INT_DMA_TERM_CNT                  (1 << 11)
#define INT_DMA_ERR                       (1 << 12)

#define INT_GSW_STAT                      (1 << 18)
#define INT_GSW_TS_TX_CMPLT               (1 << 19)
#define INT_GSW_FS_RX_CMPLT               (1 << 20)
#define INT_GSW_TS_Q_EMPTY                (1 << 21)
#define INT_GSW_FS_Q_FULL                 (1 << 22)


/* Orion Access Method */
/* It might modified if we should do swap ,11/6/2004 13:26 knight@broadweb.com.tw */
#define orn_inb(addr)           (*((u_int8 *)(addr)))
#define orn_inw(addr)           (*((u_int16 *)(addr)))
#define orn_inl(addr)           (*((u_int32 *)(addr)))

#define orn_outb(addr, value)   (*((u_int8 *)(addr)) = value)
#define orn_outw(addr, value)   (*((u_int16 *)(addr)) = value)
#define orn_outl(addr, value)   (*((u_int32 *)(addr)) = value)


#endif  // end of #ifndef _STAR_GSW_H_
