#ifndef _STAR_UHAL_H_
#define _STAR_UHAL_H_

/******************************************************************************
 * MODULE NAME:    star_uhal.h
 * PROJECT CODE:   Orion
 * DESCRIPTION:    
 * MAINTAINER:     MJLIU
 * DATE:           01 March 2004
 *
 * SOURCE CONTROL: 
 *
 * LICENSE:
 *     This source code is copyright (c) 2004 Star Semi Inc.
 *     All rights reserved.
 *
 * REVISION HISTORY:
 *    01 March 2004  -  MJLIU	- Initial Version v1.0
 *
 *
 * SOURCE:
 * ISSUES:
 * NOTES TO USERS:
 ******************************************************************************/


/* 
 * defined in star_cpu_mode.s
 */
extern int     uHALir_ReadMode(void);
extern void    uHALir_WriteMode(unsigned int);
extern int     uHALir_EnterSvcMode(void);
extern int     uHALir_EnterLockedSvcMode(void);
extern void    uHALir_ExitSvcMode(unsigned int);


/* 
 * defined in star_cpu_mmu.s
 */
extern void    uHALr_Cpu_Init_MMU(int);
extern void    uHALr_Cpu_Reset_MMU(void);

extern void    uHALr_Cpu_Disable_ICache(void);
extern void    uHALr_Cpu_Disable_DCache(void);
extern void    uHALr_Cpu_Disable_Write_Buffer(void);
extern void    uHALr_Cpu_Disable_BTB(void);
extern void    uHALr_Cpu_Disable_Big_Endian(void);

extern int     uHALir_MMUSupported(void);
extern int     uHALir_ReadMMUConfiguration(void);
extern void    uHALir_WriteMMUConfiguration(int);


/* 
 * defined in star_cpu_stack.s
 */
extern void    uHALr_Cpu_Setup_SVC_Mode_Stack(void);
extern void    uHALr_Cpu_Setup_IRQ_Mode_Stack(void);
extern void    uHALr_Cpu_Setup_FIQ_Mode_Stack(void);


#endif
