#ifndef _STAR_SYS_APB_MEMORY_MAP_H_
#define _STAR_SYS_APB_MEMORY_MAP_H_

/******************************************************************************
 * MODULE NAME:    star_sys_apb_memory_map.h
 * PROJECT CODE:   Orion
 * DESCRIPTION:    
 * MAINTAINER:     MJLIU
 * DATE:           05 June 2003
 *
 * SOURCE CONTROL: 
 *
 * LICENSE:
 *     This source code is copyright (c) 2003 Star Semi Inc.
 *     All rights reserved.
 *
 * REVISION HISTORY:
 *    05 June 2003  -  MJLIU	- Initial Version v1.0
 *    11 June 2003  -  MJLIU	- Initial Version v1.1
 *
 *
 * SOURCE:
 * ISSUES:
 * NOTES TO USERS:
 ******************************************************************************/

#include "sys_memory_map.h"

#define APB_DEVICES_BASE_ADDR                          SYS_MEM_MAP_ADDR(APB_DEVICES_BASE)

#define APB_DEVICES_GSW_BASE_OFFSET                    0x00000000
#define APB_DEVICES_IDP_BASE_OFFSET                    0x02000000
#define APB_DEVICES_USB_BASE_OFFSET                    0x04000000
#define APB_DEVICES_MISC_BASE_OFFSET                   0x06000000
#define APB_DEVICES_POWER_MANAGEMENT_BASE_OFFSET       0x07000000
#define APB_DEVICES_UART_BASE_OFFSET                   0x08000000
#define APB_DEVICES_TIMER_BASE_OFFSET                  0x09000000
#define APB_DEVICES_WATCHDOG_TIMER_BASE_OFFSET         0x0A000000
#define APB_DEVICES_REAL_TIME_CLOCK_BASE_OFFSET        0x0B000000
#define APB_DEVICES_GPIO_BASE_OFFSET                   0x0C000000
#define APB_DEVICES_INTERRUPT_CONTROLLER_BASE_OFFSET   0x0D000000


#define APB_DEVICES_MEM_MAP_ADDR(regname)   (APB_DEVICES_BASE_ADDR + APB_DEVICES_##regname##_OFFSET)

#define APB_DEVICES_MEM_MAP_VALUE(regname)  (*((unsigned int volatile *)APB_DEVICES_MEM_MAP_ADDR(regname)))


/*
 * macro defines for MISC(ARBITER_DECODER) control register
 */
#define MISC_BASE_ADDR                             (APB_DEVICES_BASE_ADDR + APB_DEVICES_MISC_BASE_OFFSET)

#define MISC_MEMORY_REMAP                          (*((unsigned int volatile *)(MISC_BASE_ADDR + 0x00)))
#define MISC_RESET_STATUS                          (*((unsigned int volatile *)(MISC_BASE_ADDR + 0x10)))
#define MISC_ENDIAN_CONFIGURE                      (*((unsigned int volatile *)(MISC_BASE_ADDR + 0x20)))
#define MISC_AHB_ARBITOR_PRIORITY_CONTROL          (*((unsigned int volatile *)(MISC_BASE_ADDR + 0x30)))
#define MISC_AHB_ARBITOR_EARLY_TERMINATION_CONTROL (*((unsigned int volatile *)(MISC_BASE_ADDR + 0x34)))

#define ENABLE_MEMORY_REMAPPING                    ((MISC_MEMORY_REMAP) = (1))


#endif // end of #ifndef _STAR_SYS_APB_MEMORY_MAP_H_


