#ifndef _STAR_SYS_MEMORY_MAP_H_
#define _STAR_SYS_MEMORY_MAP_H_

/******************************************************************************
 * MODULE NAME:    sys_memory_map.h
 * PROJECT CODE:   Orion
 * DESCRIPTION:    
 * MAINTAINER:     MJLIU
 * DATE:           05 June 2003
 *
 * SOURCE CONTROL: 
 *
 * LICENSE:
 *     This source code is copyright (c) 2003 Star Semi Inc.
 *     All rights reserved.
 *
 * REVISION HISTORY:
 *    05 June 2003  -  MJLIU	- Initial Version v1.0
 *
 *
 * SOURCE:
 * ISSUES:
 * NOTES TO USERS:
 ******************************************************************************/
 
#include "sys_typedef.h" 

/*
 * sytem memory mapping after reset
 */
#define SYS_ALIASED_FLASH_BASE_ADDR            0x00000000
#define SYS_FLASH_BASE_ADDR                    0x10000000
#define SYS_DDR_SDRAM_BASE_ADDR                0x20000000
#define SYS_STATIC_MEMORY_CONTROLLER_BASE_ADDR 0x30000000
#define SYS_DDR_SDRAM_CONTROLLER_BASE_ADDR     0x40000000
#define SYS_RESERVED_REGION_1_BASE_ADDR        0x50000000
#define SYS_DMAC_BASE_ADDR                     0x60000000
#define SYS_APB_DEVICES_BASE_ADDR              0x70000000

#define SYS_PCMCIA_BRIDGE_CONTROLLER_BASE_ADDR 0x80000000
#define SYS_PCMCIA_MEMORY_BASE_ADDR            0x90000000

#define SYS_PCI_BRIDGE_DATA_REG_BASE_ADDR      0xA0000000
#define SYS_PCI_BRIDGE_ADDR_REG_BASE_ADDR      0xA4000000
#define SYS_PCI_IO_SPACE_BASE_ADDR             0xA8000000
#define SYS_PCI_MEMORY_SPACE_BASE_ADDR         0xB0000000

#define SYS_USB11_CONFIG_BASE_ADDR             0xC0000000
#define SYS_USB11_OPERATION_REG_BASE_ADDR      0xC4000000
#define SYS_USB20_CONFIG_BASE_ADDR             0xC8000000
#define SYS_USB20_OPERATION_REG_BASE_ADDR      0xCC000000

#define SYS_RESERVED_REGION_2_BASE_ADDR        0xD0000000
#define SYS_RESERVED_REGION_3_BASE_ADDR        0xE0000000
#define SYS_RESERVED_REGION_4_BASE_ADDR        0xF0000000

#define SYS_MEM_MAP_ADDR(region_name)    (SYS_##region_name##_ADDR)

#define SYS_MEM_MAP_VALUE(region_name)	 (*((unsigned int volatile *)SYS_MEM_MAP_ADDR(region_name)))

#endif // end of #ifndef _STAR_SYS_MEMORY_MAP_H_